//AB/ Project File Selection
//AB/     Object prj is a View_Project
//AB/         Set ProjectName to "File Selection"
//AB/         Set ProjectFileName to "Selection.VW"
//AB/         Set GenerateFileName to "NONAME"

// Project Object Structure
//   oSelection is a dbView
//     oSelectGrid is a Grid
//       oSelectedFiles is a Set
//       oDataFields is a Set
//     oStartBtn is a Button
//     oWkSpcBtn is a Button
//     oRefresh is a Button
//     oSelDeSel is a Group
//       oSelectAllBtn is a Button
//       oDeSelectAllBtn is a Button
//     oSilent is a RadioGroup
//       oErrorBox is a Radio
//       oLogLine is a Radio

// Register all objects
Register_Object oDataFields
Register_Object oDeSelectAllBtn
Register_Object oErrorBox
Register_Object oLogLine
Register_Object oRefresh
Register_Object oSelDeSel
Register_Object oSelectAllBtn
Register_Object oSelectedFiles
Register_Object oSelectGrid
Register_Object oSelection
Register_Object oSilent
Register_Object oStartBtn
Register_Object oWkSpcBtn


//AB/     AppBuild VIEW


    //AB-StoreTopStart
    Property Integer pbNotOpen    Public False
    Enum_List
        Define Error_To_Screen
        Define Error_To_LogFile
    End_Enum_List
    Property Integer pbDuplicateRecords Public Error_To_Screen
    //AB-StoreTopEnd

    //AB-IgnoreStart


    //AB-IgnoreEnd

    ACTIVATE_VIEW Activate_oSelection FOR oSelection

    Object oSelection is a dbView

        //AB-StoreTopStart
        Property Integer piGridFilled Public 0  // Has the grid allready been filled ?

        Use Rebuild.dg  //  Rebuilding progress dialog
        Procedure Activate
            Integer iGridFilled

            Get piGridFilled to iGridFilled
            If (iGridFilled = 0) Begin
                Send FillGrid of oSelectGrid
                Set piGridFilled to 1
            End

            Forward Send Activate
        End_Procedure // Activate
        //AB-StoreTopEnd

        Set Label to "Rebuild Data Files View"
        Set Size to 288 351
        Set Location to 9 34

        //AB-DDOStart


        //AB-DDOEnd

        Object oSelectGrid is a Grid

            //AB-StoreTopStart
            Set Select_Mode to Multi_Select
            //AB-StoreTopEnd

            Set CurrentCellColor to clLime
            Set CurrentCellTextColor to clFuchsia
            Set CurrentRowColor to clLime
            Set CurrentRowTextColor to clFuchsia
            Set TextColor to clBlack
            Set Size to 212 331
            Set Location to 10 9

            Set Line_Width to 5 0

            Set Form_Width    item 0 to 17
            Set Header_Label  item 0 to "Rebuild ?"

            Set Form_Width    item 1 to 34
            Set Header_Label  item 1 to "Number"

            Set Form_Width    item 2 to 50
            Set Header_Label  item 2 to "File Name"

            Set Form_Width    item 3 to 127
            Set Header_Label  item 3 to "User Name"

            Set Form_Width    item 4 to 95
            Set Header_Label  item 4 to "Remarks"


            //AB-StoreStart
            Set Select_Mode to Multi_Select
            Set highlight_row_state To True


            // number of files selected
            Property Integer piSelectedFiles Public 0

            // Stores file numbers of selected data files
            Object oSelectedFiles  Is A Set
            End_Object //  oSelectedFiles

            // Stores field numbers of data fields belonging to current data files
            Object oDataFields     Is A Set
            End_Object //  oDataFields

            // Travers through filelist to obtain info on files on list
            // when a file is found, add its info to grid
            Procedure FillGrid
                Integer iFile iFileOpen hoCursor iItems i
                String sName

                Get Object_Id Of (Cursor_Control (Self)) To hoCursor
                If (hoCursor Gt 0) Begin
                    Send Cursor_Wait To hoCursor
                End

                Send Delete_Data

                Move 0 to iFile
                Repeat
                    Get_Attribute Df_File_Next_Used Of iFile to iFile
                    If ((iFile Gt 0) And (iFile Ne 50) And (iFile Ne 250)) Begin

                        Get_Attribute Df_File_Root_Name of iFile to sName

                        // Ignore Error 4177, of error ocurse then file can not be rubuild
                        Send Ignore_Error To Error_Object_Id 4177
                        Open iFile Mode Df_Exclusive
                        Get_Attribute Df_File_Opened of iFile to iFileOpen

                        Send Add_Item 0 "" // add CheckBox for file to grid
                        Set Form_Bitmap         Item (Item_Count(Self)-1) to "ChkOffE.bmp"


                        Send Add_Item Msg_None iFile  //  add file number to grid

                        Send Add_Item Msg_None sName  //  add file rootname to grid

                        Get_Attribute Df_File_Display_Name of iFile to sName
                        Send Add_Item Msg_None sName  //  add file user name to grid

                        If (iFileOpen Eq 0) Begin
                            Send Add_Item 0 "File is alias file, or is in use."
                        End
                        Else Begin
                            Send Add_Item 0 ""
                        End
                        Move (Item_Count(Self) - 5) to iItems

                        If (iFileOpen Ne 0) Begin
                            For i From iItems to (iItems + 4)
                                Set Entry_State Item i to False
                            Loop
                        End
                        Else Begin
                            For i From iItems to (iItems + 4)
                                Set Shadow_State Item i to True
                            Loop
                        End

                    End
                Until (iFile Eq 0)
                Close DF_All
                Set Dynamic_Update_State to False
                Send Paint
                Set Dynamic_Update_State to True
                If (hoCursor Gt 0) Begin
                    Send Cursor_Ready To hoCursor
                End
            End_Procedure // FillGrid

            Procedure Select_Toggling Integer iItem Integer iState
                Integer iRow
                String sValue

                If (iItem = Current) Begin
                    Get Current_Item to iItem
                    If (iItem Lt 4) Begin
                        Move 0 to iRow
                    End
                    Else Begin
                        Move (iItem / 5) to iRow
                    End
                    Move (iRow * 5) to iItem
                    Get Value Item (iItem + 4) to sValue
                    If (sValue Eq "") Begin
                        Forward Send Select_Toggling iItem iState
                        Get Select_State Item iItem to iState
                        Set Form_Bitmap Item iItem to (If ((iState) = DfTrue, "ChkOnE.bmp", "ChkOffE.bmp"))
                    End
                    Else Begin
                        Send Stop_Box "This file can not be selected, in use or a alias file" "Not Selectable"
                    End
                    Send Paint
                End
            End_Procedure // Select_Toggling

            // selects current item from pulldown menu
            // by checking checkbox in current row
            Procedure DoSelectItem
                Integer iCurItem iCurCol iMax
                String sValue

                Move (Item_Count(Self)-1) to iMax
                If (iMax Lt 4) Procedure_Return 1 // need at least one column filled to deselect

                Get Current_Col  to iCurCol
                Get Current_Item to iCurItem

                If      (iCurCol Eq 1) Add -1  to iCurItem
                Else If (iCurCol Eq 2) Add -2  to iCurItem
                Else If (iCurCol Eq 3) Add -3  to iCurItem
                Else If (iCurCol Eq 4) Add -4 to iCurItem

                Get Value Item (iCurItem + 4) to sValue
                If (sValue Eq "") Begin
                    Set Form_Bitmap  Item iCurItem to "ChkOnE.bmp"
                    Forward Send Select_Toggling iCurItem DfTrue
                End
                Else Begin
                    Send Stop_Box "This file can not be selected, it is in use or a alias file" "Not Selectable"
                End
                Send Paint
            End_Procedure // DoSelectItem

            // Deselect current item from pulldown menu
            // by unchecking checkbox in current row
            Procedure DoDeselectItem
                Integer iCurItem iCurCol iMax

                Move (Item_Count(Self)-1) to iMax

                If (iMax Lt 4) Procedure_Return 1 // need at least 1 file in list to deselect

                Get Current_Col  to iCurCol
                Get Current_Item to iCurItem

                If      (iCurCol Eq 1) Add -1  to iCurItem
                Else If (iCurCol Eq 2) Add -2  to iCurItem
                Else If (iCurCol Eq 3) Add -3  to iCurItem
                Else If (iCurCol Eq 4) Add -4 to iCurItem

                Set Form_Bitmap Item iCurItem to "ChkOffE.bmp"
                Forward Send Select_Toggling iCurItem DfFalse
                Send Paint
            End_Procedure // DoDeselectItem

            // Selects all Items (checks each row)
            Procedure DoSelectAll
                Integer iMax i
                String sValue

                Move (Item_Count(Self)-1) to iMax

                If (iMax Lt 4) Procedure_Return 1 // need at least 1 file in list to be selected

                Set Dynamic_Update_State to False

                Move 0 to i
                Repeat
                    Get Value Item (i + 4) to sValue
                    If (sValue Eq "") Begin
                        Set Form_Bitmap Item i to "ChkOnE.bmp"
                        Forward Send Select_Toggling i DfTrue
                    End
                    add 5 to i
                Until ( i Gt iMax)

                Send Paint
                Set Dynamic_Update_State to True
            End_Procedure // DoSelectAll

            // Deselect all items (Unchecks each row)
            Procedure DoDeSelectAll
                Integer iMax i

                Move (Item_Count(Self)-1) to iMax

                If (iMax Lt 4) Procedure_Return 1 // need at least 1 file in list to be unchecked

                Set Dynamic_Update_State to False

                Move 0 to i
                Repeat
                    Set Form_Bitmap Item i to "ChkOffE.bmp"
                    Forward Send Select_Toggling i DfFalse
                    Add 5 to i
                Until (i Gt iMax)

                Set Dynamic_Update_State to True
                Send Paint
            End_Procedure // DoDeSelectAll

            //  *** Here is Where the actual rebuilding starts ***

            // do we have any selected files?
            // While we're at it, if we do have selected files, add them to an array for later use
            Function DoCheckForSelections Returns Integer
                Integer i iMax iSelect iSelArray

                Get Object_ID of oSelectedFiles     to iSelArray

                Send Delete_Data of iSelArray      // Clear array of selected file numbers

                Move ((Item_Count(Self))-1) to iMax
                Move 0 to iSelect  // we start with 0 selected Items

                Move 0 to i  // 1st checkbox
                If (iMax Gt 0) Begin
                    Repeat
                        If (Select_State(Self,i)) Begin
                            Send Add_Element of iSelArray     (Value(Self,(i + 1)))
                            Increment iSelect
                        End
                        Add 5 to i // Next checkbox
                    Until (i Gt iMax)
                End
                Set piSelectedFiles to iSelect

                If (iSelect Le 0) Begin
                    Send Stop_Box "No Files Selected to Rebuild" "Error"
                    Function_Return 1
                End
                Function_Return  0
            End_Function // DoCheckForSelections

            // *** DoRebuild *** main rebuild procedure
            Procedure DoConvert
                Integer iRetVal i iMax iSelArray iSelect iProgDg iLogObj iYesNo
                String sWorkSpaceName

                Get YesNo_Box "Are you sure you want to start the rebuilding? \nData loss may occure, be sure you backed up your data files" "Start" to iYesNo
                If (iYesNo Eq MBR_Yes) Begin
                    Get psWorkSpaceName to sWorkSpaceName
                    Get Object_ID of oSelectedFiles           to iSelArray
                    Get Object_Id of RebuildDg                to iProgDg
                    Get Object_ID of (oLogObject(Main(Self))) to iLogObj

                    Send InitLogFilePath of iLogObj "Programs"
                    Send LogOn           of iLogObj
                    Send LogTimeDate     of iLogObj "Started Rebuild data files at"
                    Send LogLine         of iLogObj ""
                    Send LogLine         of iLogObj ("Workspace:" * sWorkspaceName)

                    Get DoCheckForSelections to iRetVal
                    If (iRetVal Ne 0) Procedure_Return 1 // stop if non-zero returned

                    Get piSelectedFiles to iSelect
                    Move (Item_Count(iSelArray)-1) to iMax

                    For i  From 0 to iMax

                        // Call procededure to rebuild files, first write them to a .asc file, then zerofile
                        // then reread the records to the database

                        Send RebuildFiles (Integer_Value(iSelArray,i)) //(String_Value(iSelNameArray,i))
                        Send GetOut of iProgDg
                    Loop

                    Send DoDeSelectAll  // Uncheck All files in grid

                    Send LogLine of iLogObj
                    Send LogTimeDate of iLogObj "Completed Rebuild of files at"
                    Send LogLine of iLogObj "=========================================="
                    Send LogLine of iLogObj
                    Send LogOff of iLogObj


                    // Show user we are done and allow user to view log file
                    Get LogOk of iLogObj to i
                    If (i Eq 0) Begin
                        Get YesNo_Box "View Log File?" "All Files Rebuild" to i
                        If (i Eq MBR_Yes) Send ViewLogFile of iLogObj
                    End
                    Else Send info_box "All Files Rebuild" "Process Complete"
                End
            End_Procedure // DoConvert

            // Rebuilds one File at a Time
            // Hier moet dus de code van Chris komen die een paar regels boven word aangeroepen
            // Eerst het geselecteerde file nummer omzetten naar een .asc bestand
            // dan zerofile en dan opnieuw inlezen

            Procedure RebuildFiles Integer iFile
                Integer bNotOpen
                Set pbNotOpen to False
                Send ExportFileData iFile
                // if file could not be opened exclusive there will be no rebuilding and pbNotOpen
                // will contain a 0, in that case abort the rebuild
                Get pbNotOpen to bNotOpen
                If (bNotOpen Eq False) Begin
                    ZeroFile iFile
                    Send ImportFileData iFile
                End
                Close Df_All
            End_Procedure // RebuildFiles

            Procedure ExportFileData Integer iFileNumber
                Integer iRecords iChannel bEof iProgress iCounter iProgressText iFileOpen iLogObj iFileAlias iProgDg
                String sWorkSpaceStr sWorkSpaceName sDataPath sFileName sTmp sUserFileName
                Handle hFile

                Get Object_Id of (oRebuildProgress(RebuildDg(Self))) to iProgress
                Get Object_Id of (oRebuildText    (RebuildDg(Self))) to iProgressText
                Get Object_Id of (oLogObject      (Main     (Self))) to iLogObj
                Get Object_Id of RebuildDg                           to iProgDg

                Move "WorkSpaces\" to sWorkSpaceStr
                Get psWorkSpaceName to sWorkSpaceName
                Append sWorkSpaceStr sWorkSpaceName
                Get_Profile_String sWorkSpaceStr "DataPath" to sDataPath

                Send Ignore_error To Error_object_id 75
                Send Ignore_Error To Error_Object_Id 4177

                Open iFileNumber Mode DF_EXCLUSIVE

                Get_Attribute Df_File_Opened       of iFilenumber to iFileOpen
                Get_Attribute Df_File_Root_Name    of iFileNumber to sFileName
                Get_Attribute Df_File_Display_Name of iFileNumber to sUserFileName

                // Only start rebuild procedure if the file is opened, if it is not
                // an error message has apeared and we write a line to the log. It is of no
                // use to start rebuilding if opening exclisive failed
                Case Begin
                    // Filenumber 50 is flexerrs, and 250 is abdata. Both do not and can not be rebuild
                    Case ((iFileNumber Eq 250) Or (iFileNumber Eq 50))
                        Send Stop_Box ("File:" * sFileName * "(" + sUserFileName + ")" * "will not be rebuild") "No Data File"
                        Set pbNotOpen to True
                        Send LogLine         of iLogObj ("No Rebuild of File" * (String(iFileNumber)) * (UpperCase(sFileName)) * "(" + sUserFileName + ")" * "No data file")
                        Case Break
                     //Only start a rebuild if th file is opened exlusivly. In other cases do not rebuild
                    Case (iFileOpen Eq DfTrue)
                        // Do not check on this attribute before you are sure the file is opened.
                        // If checked earlier and the file was not open then you get a error 75,
                        // and the program will be terminated

                        Open sFileName as hFile Mode Df_Exclusive
                        // Ignore error 4105, else we get a file not opened en app will exit
                        Send Ignore_Error To Error_Object_Id 4105
                        Get_Attribute Df_File_Opened of hFile to iFileOpen
                        If (iFileOpen Eq DfFalse) Move 1 to iFileAlias

                        // Is the file no alias? then rebuild
                        If (iFileAlias Eq 0) Begin
                            Get_Attribute Df_File_Records_Used of iFileNumber to iRecords

                            Send ShowProgress of iProgDg sFileName
                            Move "Rebuilding File " to sTmp
                            Append sTmp iFileNumber " " sFileName " (" sUserFileName ")"
                            Send LogLine of iLogObj sTmp

                            Append sDataPath "\" sFileName ".asc"

                            Set Value of iProgressText to ("Exporting Data from file:" * sFileName * "(" + sUserFileName + ")" * "(#" + (String(iFileNumber)) + ")")

                            Get Seq_Open_Output_Channel sDataPath to iChannel
                            If iChannel Lt 0 Begin
                                Send Stop_Box (sFileName * "(" + sUserFileName + ")" * "Could not be opened!") "Rebuild Files"
                                Send LogLine of iLogObj ("ERROR:" * sFileName * "(" + sUserFileName + ")" * "Could not be opened. File is not Rebuild")
                                Procedure_Return
                            End
                            Set Minimum_Position of iProgress to 0
                            Set Step_Value of iProgress to 1
                            Set Maximum_Position of iProgress to iRecords
                            Send Cursor_Wait To (Cursor_Control(Current_Object))

                            Writeln iRecords

                            Clear iFileNumber
                            Repeat
                                VFind iFileNumber 0 Gt
                                Increment iCounter
                                Move (FindErr) to bEof
                                If (bEof Eq DfFalse) Begin
                                    Send DoWriteData iFileNumber
                                End

                                Set Current_Position of iProgress to iCounter

                            Until (bEof = DfTrue)


                            Send Seq_Close_Channel iChannel
                            Send Cursor_Ready To (Cursor_Control(Current_Object))
                            Case Break
                        End
                        // If file is an alias then send a logline and do not rebuild
                        Else Begin
                            Send LogLine of iLogObj ((String(iFileNumber)) * (UpperCase(sFileName)) * "(" + sUserFileName + ")" * "will not be rebuild. Because file is a alias file")
                            Set pbNotOpen to True
                            Case Break
                        End
                    // All other cases (this should only occur if the file could not be opened exclusive
                    Case Else
                        Set pbNotOpen to True
                        Send Stop_Box ((UpperCase(sFileName)) * "File could not be opened exclusivly, rebuilding of this file will abort") sFileName
                        Send LogLine         of iLogObj ("ERROR:  File" * (String(iFileNumber)) * (UpperCase(sFileName)) * "(" + sUserFileName + ")" * "Could not be rebuild")
                        Case Break
                Case End
            End_Procedure // ExportFileData

            Procedure DoWriteData Integer iFileNumber
                Integer iField iFieldType iMax iOverlap


                Get_Attribute Df_File_Number_Fields of iFileNumber to iMax
                For iField From 0 to iMax
                    Move iFileNumber to FileNumber
                    Move iField to FieldIndex
                    Get_Attribute Df_Field_type   of iFileNumber iField to iFieldType
                    Get_Attribute Df_Field_Overlap of iFileNumber iField to iOverlap
                    If iFieldType Eq Df_Text Begin
                        Write_Hex Indirect_File.Recnum
                        Writeln
                    End
                    Else If (Not(iOverlap)) Begin
                        Writeln Indirect_File.Recnum
                    End
                Loop
            End_Procedure // DoWriteData

            Procedure ImportFileData Integer iFileNumber
                Integer iRecords iChannel iProgress iProgressText iCounter iProgDg
                String sDataPath sWorkSpaceStr sWorkSpaceName sFileName sUserFileName

                Get Object_Id of (oRebuildProgress(RebuildDg(Self))) to iProgress
                Get Object_Id of (oRebuildText    (RebuildDg(Self))) to iProgressText
                Get Object_Id of RebuildDg                           To iProgDg

                Move "WorkSpaces\" to sWorkSpaceStr
                Get psWorkSpaceName to sWorkSpaceName
                Append sWorkSpaceStr sWorkSpaceName
                Get_Profile_String sWorkSpaceStr "DataPath" to sDataPath

                Open iFileNumber

                Set_Attribute Df_File_Mode Of iFileNumber To Df_FileMode_Single_User
                Get_Attribute Df_File_Root_Name of iFileNumber to sFileName
                Get_Attribute Df_File_Display_Name of iFileNumber to sUserFileName

                Set Value of iProgressText to ("Importing Data To File:" * sFileName * "(" + sUserFileName + ")" * "(#" + (String(iFileNumber)) + ")")

                Append sDataPath "\" sFileName ".asc"

                Get Seq_Open_Input_Channel sDataPath to iChannel
                If iChannel Lt 0 Begin
                    Send Stop_Box (sFileName * "Could not be opened!") "Rebuild Files"
                    Procedure_Return

                End

                ReadLn iRecords
                Clear iFileNumber

                Set Minimum_Position of iProgress to 0
                Set Maximum_Position  of iProgress to iRecords
                Set Step_Value        of iProgress to 1

                Repeat
                    If (Not(SeqEof)) Begin
                        Increment iCounter
                        Send DoReadData iFileNumber
                        Set Current_Position of iProgress to iCounter
                    End
                Until (SeqEof)

                Send Seq_Close_Channel iChannel
                Send Cursor_Ready To (Cursor_Control(Current_Object))

                EraseFile sDataPath

            End_Procedure // ImportFileData

            Procedure DoReadData Integer iFileNumber
                Integer iField iFieldType iMax iOverlap iProgress
                String sValue


                Get_Attribute Df_File_Number_Fields of iFileNumber to iMax
                Get Object_Id of (oRebuildProgress(RebuildDg(Self))) to iProgress

                For iField From 0 to iMax
                    Move iFileNumber to FileNumber
                    Move iField      to FieldIndex
                    Get_Attribute Df_Field_Type     of iFileNumber iField To iFieldType
                    Get_Attribute Df_Field_Overlap  of iFileNumber iField to iOverlap

                    If iFieldType Eq Df_Text Begin
                        Read_Hex sValue
                        If (Not(SeqEof)) Begin
                            Readln
                        End
                    End
                    Else If ((Not(iOverLap)) And (Not(SeqEof))) Begin
                        Readln sValue
                    End
                    Move sValue To Indirect_File.Recnum
                Loop
                If (Not(SeqEof)) Begin
                    SaveRecord iFileNumber
                    Unlock
                End
            End_Procedure // DoReadDate

            //AB-StoreEnd

        End_Object    // oSelectGrid

        object oErrorSystem is a ErrorSystem
            procedure Error_Report integer ErrNum integer Err_Line string ErrMsg
                if ErrNum eq 28 send handle_28 ErrNum Err_Line ErrMsg
                Else If ErrNum Eq 4 Send Handle_4 ErrNum Err_Line ErrMsg
                else forward send Error_Report ErrNum Err_Line ErrMsg
            end_procedure

            procedure handle_28 integer ErrNum integer Err_Line string ErrMsg
                Integer bDuplicateRecords iLogObj

                Get Select_State of (oErrorBox(oSilent(oSelection(Self)))) to bDuplicateRecords
                If (bDuplicateRecords Eq True) Begin
                    Send Stop_Box "Error 28: Seek to unwritten extent" "Error"
                End
                Else Begin
                    Get Object_Id of (oLogObject(Main(Self))) to iLogObj
                    Send LogLine of iLogObj ("ERROR 28: Seek to unwritten extend" * ErrMsg)
                End
            end_procedure

            Procedure Handle_4 Integer ErrNum Integer Err_Line String ErrMsg
                Integer bDuplicateRecords iLogObj

                Get Select_State of (oErrorBox(oSilent(oSelection(Self)))) to bDuplicateRecords
                If (bDuplicateRecords Eq True) Begin
                    Send Stop_Box ("Error 4: No Duplicate Records Allowed," * ErrMsg) "Error"
                End
                Else Begin
                    Get Object_Id of (oLogObject(Main(Self))) to iLogObj
                    Send LogLine of iLogObj ("ERROR 4: No duplicate Records allowed," * ErrMsg)
                End
            End_Procedure //

        end_object


        Object oStartBtn is a Button
            Set Label to "&Rebuild Data"
            Set Default_State to TRUE
            Set Size to 14 60
            Set Location to 251 280

            //AB-StoreStart
            Procedure OnClick
                Send DoConvert of oSelectGrid
            End_Procedure // OnClick

            //AB-StoreEnd

        End_Object    // oStartBtn

        Object oWkSpcBtn is a Button
            Set Label to "Change &WorkSpace"
            Set Default_State to TRUE
            Set Size to 14 70
            Set Location to 231 198

            //AB-StoreStart
            Procedure OnClick
                Send ChangeWorkSpace of Main
            End_Procedure // OnClick
            //AB-StoreEnd

        End_Object    // oWkSpcBtn

        Object oRefresh is a Button
            Set Label to "Re&fresh View"
            Set Size to 14 70
            Set Location to 250 198

            //AB-StoreStart
            Procedure OnClick
                Send FillGrid to oSelectGrid
            End_Procedure // OnClick

            //AB-StoreEnd

        End_Object    // oRefresh

        Object oSelDeSel is a Group
            Set Size to 47 62
            Set Location to 222 11
            Object oSelectAllBtn is a Button
                Set Label to "Select &All"
                Set Location to 10 7

                //AB-StoreStart
                Procedure OnClick
                    Send DoSelectAll of oSelectGrid
                End_Procedure // OnClick

                //AB-StoreEnd

            End_Object    // oSelectAllBtn

            Object oDeSelectAllBtn is a Button
                Set Label to "&DeSelect All"
                Set Location to 28 7

                //AB-StoreStart
                Procedure OnClick
                    Send DoDeSelectAll of oSelectGrid
                End_Procedure // OnClick

                //AB-StoreEnd

            End_Object    // oDeSelectAllBtn

        End_Object    // oSelDeSel

        Object oSilent is a RadioGroup
            Set Label to "Handle Duplicate Errors"
            Set Size to 47 121
            Set Location to 222 74
            Object oErrorBox is a Radio
                Set Label to "With a message (Stop box)"
                Set Size to 10 101
                Set Location to 13 5
            End_Object    // oErrorBox

            Object oLogLine is a Radio
                Set Label to "With a Logline  (Silent)"
                Set Size to 10 87
                Set Location to 30 5
            End_Object    // oLogLine


            //AB-StoreStart

            Procedure Notify_Select_State integer iToItem integer iFromItem
                Forward Send Notify_Select_State iToItem iFromItem
                If (iToItem Eq 0) Begin
                    Set pbDuplicateRecords to Error_To_Screen
                End
                Else If (iToItem Eq 1) Begin
                    Set pbDuplicateRecords to Error_To_LogFile
                End
            End_Procedure

            // If you set Current_radio you must set this after the
            // radio objects have been created AND after Notify_select_State has been
            // created. i.e. Set in bottom-code at end!!
            //Set Current_Radio to 0

            //AB-StoreEnd

        End_Object    // oSilent


        //AB-StoreStart
        On_Key Key_Alt+Key_R Send KeyAction of oStartBtn
        On_Key Key_Alt+Key_A Send KeyAction of oSelectAllBtn
        On_Key Key_Alt+Key_A Send KeyAction of oDeSelectAllBtn
        On_Key Key_Alt+Key_W Send KeyAction of oWkSpcBtn
        On_Key Key_Alt+Key_F Send KeyAction of oRefresh
        //AB-StoreEnd

    End_Object    // oSelection


    //AB-StoreStart


    //AB-StoreEnd

//AB/     End_Object    // prj
